H=-3000;

dxx1=0.125;
dyy1=0.125;
xx1=0+dxx1/2:dxx1:45-dxx1/2;
yy1=-21+dyy1/2:dyy1:21-dyy1/2;

tt1=H*ones(length(yy1),length(xx1));

tt1(1,:)=0;
tt1(end,:)=0;
fid=fopen('no_land_3d.bin','w','b'); fwrite(fid,tt1','real*8'); fclose(fid);
fid=fopen('zeros_3d.bin','w','b'); fwrite(fid,0*tt1','real*8'); fclose(fid);


tt1((length(yy1)/2-0.25*length(yy1)):(length(yy1)/2+0.25*length(yy1)),(length(xx1)/2-0.1*length(xx1)):(length(xx1)/2+0.1*length(xx1)))=0;
fid=fopen('island_3d.bin','w','b'); fwrite(fid,tt1','real*8'); fclose(fid);

tt1=H*ones(length(yy1),length(xx1));
tt1(1,:)=0;
tt1(end,:)=0;

i0=length(xx1)/2;
j0=length(yy1)/2;
%R=1.03*length(yy1)/4;
R=1.03*length(yy1)/8;

for i=1:length(xx1)
  for j=1:length(yy1)
    if (((i-i0)^2+(j-j0)^2)^0.5<=R)
      tt1(j,i)=0;
    end
  end
end

figure;
contourf(tt1);colorbar;
fid=fopen('circ_island_3d.bin','w','b'); fwrite(fid,tt1','real*8'); fclose(fid);
tmp1=tt1;
figure;

%calculate total geothermal assuming mean of 0.1 W/m^2
area=0.1*sum(cos(yy1(2:end-1)/180*pi));

w=7;
for i=1:length(xx1)
  tt1(:,i)=H-H*exp(-(yy1').^2/w^2)/2;
end
contourf(xx1,yy1,tt1);colorbar;

tt1(1,:)=0;
tt1(end,:)=0;
fid=fopen('equator_ridge_3d.bin','w','b'); fwrite(fid,tt1','real*8'); fclose(fid);

tt2=zeros(length(yy1),length(xx1));
r1=85:86;
tt2(r1,:)=area/sum(cos(yy1(r1)/180*pi));
tt2(r1,1)
fid=fopen('equator_ridge_GT_3d.bin','w','b'); fwrite(fid,tt2','real*8'); fclose(fid);

% following the literature there is a factor 4 between the heating at the
% ridges and the background heating 
tt3=1+3*exp(-(yy1').^2/w^2);
tt3(1)=0;
tt3(end)=0;
cc=0;
cc1=0;
for i=1:length(xx1)
  tt1(:,i)=tt3.*tmp1(:,i)/H;
%  cc=cc+sum(tt1(2:end-1,i)'.*cos(yy1(2:end-1)/180*pi))/sum(cos(yy1(2:end-1)/180*pi));
  cc=cc+sum(tt1(2:end-1,i)'.*cos(yy1(2:end-1)/180*pi));
  cc1=cc1+sum(tmp1(2:end-1,i)'.*cos(yy1(2:end-1)/180*pi)/H);
end
%cc=cc/length(xx1)/sum(cos(yy1(2:end-1)/180*pi));
tt1=tt1/cc*cc1*0.1;

figure;
contourf(xx1,yy1,tt1);colorbar;
title('geothermal heating in W/m^2');

%return

fid=fopen('equator_ridge_GT_factor4_3d.bin','w','b'); fwrite(fid,tt1','real*8'); fclose(fid);

w=3;
for i=1:length(xx1)
  tt1(:,i)=H-H*exp(-(yy1'-6).^2/w^2)/2;
end
contourf(xx1,yy1,tt1);colorbar;

tt1(1,:)=0;
tt1(end,:)=0;
fid=fopen('off_equator_ridge_3d.bin','w','b'); fwrite(fid,tt1','real*8'); fclose(fid);

tt2=zeros(length(yy1),length(xx1));
r1=66:67;
tt2(r1,:)=area/sum(cos(yy1(r1)/180*pi));
tt2(r1,1)
fid=fopen('off_equator_ridge_GT_3d.bin','w','b'); fwrite(fid,tt2','real*8'); fclose(fid);

% following the literature there is a factor 4 between the heating at the
% ridges and the background heating 
tt3=1+3*exp(-(yy1'-6).^2/w^2);
tt3(1)=0;
tt3(end)=0;

cc=0;
cc1=0;
for i=1:length(xx1)
  tt1(:,i)=tt3.*tmp1(:,i)/H;
%  cc=cc+sum(tt1(2:end-1,i)'.*cos(yy1(2:end-1)/180*pi))/sum(cos(yy1(2:end-1)/180*pi));
  cc=cc+sum(tt1(2:end-1,i)'.*cos(yy1(2:end-1)/180*pi));
  cc1=cc1+sum(tmp1(2:end-1,i)'.*cos(yy1(2:end-1)/180*pi)/H);
end
%cc=cc/length(xx1)/sum(cos(yy1(2:end-1)/180*pi));
tt1=tt1/cc*cc1*0.1;
figure;
contourf(xx1,yy1,tt1);colorbar;
title('geothermal heating in W/m^2');
fid=fopen('off_equator_ridge_GT_factor4_3d.bin','w','b'); fwrite(fid,tt1','real*8'); fclose(fid);


%% calculate sea-ice thickness based on geothermal balance assumption
% read Pollard surface data
aa=load('lat_Ts_pme_89S_89N.txt');
% calculate mean Ts
tmp=interp1(90-aa(:,1),aa(:,2),yy1(2:end-1));
Ts=sum(tmp.*cos(yy1(2:end-1)/180*pi))/sum(cos(yy1(2:end-1)/180*pi));
Ts=-44.4283;
Ts

rhoI=920;  % density of ice
rho0=1040;  % approximate density of sea water
CpI=2000;  % heat capacity of ice
kappa_I=1.54e-6; % heat cond. of ice 
Tf=-3.53;   % approximate freezing temp.
Q=0.1;    % bottom geothermal heating 
mu=rhoI/rho0;
h=rhoI*CpI*kappa_I*mu*(Ts-Tf)/Q
Ts1=Tf+mu*(Ts-Tf);
Ts1

fid=fopen('si_topo_uniform1_3d.bin','w','b'); fwrite(fid,(h+0*tt1)','real*8'); fclose(fid);

fid=fopen('si_topo_uniform_Ts_3d.bin','w','b'); fwrite(fid,(Ts1+0*tt1)','real*8'); fclose(fid);

uinit=(rand([180,84,21])-0.5)*1e-7;
fid=fopen('uinit_rand.bin','w','b'); fwrite(fid,uinit,'real*8'); fclose(fid);
